/*  Time-stamp: <2006-01-03 19:05:59 noike>  */
#include  "4ru.h"
#include  <glut.h>
#include  "G_clef.xbm"
#include  "F_clef.xbm"
#include  "GLcube.h"


extern int win_w;
extern int win_h;
extern double alpha;


double draw_gosen(double inter, GLdouble gosen_colors[][4], double *Lbot, double *Ltop)
{
  /*  static ˤƤȤǡưѿݤΥХإåɤʤ®ޤ  */
  /*  ޤåΰ˴Ϳ  */

  static GLdouble gosen_base[8][3];
  static GLdouble gosen[8][3];


  int i;
  int j;
  double linewidth;
  enum xyz {X=0, Y, Z };
  enum rgba {R=0, G, B, A};


  /*  夬 (0, win_h)  */
  (*Lbot) = win_h - 320;  /* θ(ǲ)  Y ɸ  */
  linewidth = 2;       /*  (ԥ) */

  gosen_base[0][X] = 0;
  gosen_base[0][Y] = 0;
  gosen_base[0][Z] = win_h;

  gosen_base[1][X] = 0;
  gosen_base[1][Y] = linewidth;
  gosen_base[1][Z] = win_h;

  gosen_base[2][X] = win_w;
  gosen_base[2][Y] = linewidth;
  gosen_base[2][Z] = win_h;

  gosen_base[3][X] = win_w;
  gosen_base[3][Y] = 0;
  gosen_base[3][Z] = win_h;

  gosen_base[4][X] = 0;
  gosen_base[4][Y] = 0;
  gosen_base[4][Z] = 0;

  gosen_base[5][X] = 0;
  gosen_base[5][Y] = linewidth;
  gosen_base[5][Z] = 0;

  gosen_base[6][X] = win_w;
  gosen_base[6][Y] = linewidth;
  gosen_base[6][Z] = 0;

  gosen_base[7][X] = win_w;
  gosen_base[7][Y] = 0;
  gosen_base[7][Z] = 0;


  /*  θ  */
  for(i = 0; i < 5; i++){
    for(j = 0; j < 8; j++){
      gosen[j][X] = gosen_base[j][X];
      gosen[j][Y] = gosen_base[j][Y] + (*Lbot) + (i * inter);
      gosen[j][Z] = gosen_base[j][Z];
    }

    glVertexPointer(3, GL_DOUBLE, 0, gosen);
    glColorPointer(4, GL_DOUBLE, 0, gosen_colors);
    glDrawElements(GL_QUADS, 24, GL_UNSIGNED_BYTE, cubeIndices);
  }


  /*  θ  */
  for(i = 0; i < 5; i++){
    for(j = 0; j < 8; j++){
      gosen[j][X] = gosen_base[j][X];
      gosen[j][Y] = gosen_base[j][Y] + ((*Lbot) + ((5 + 1) * inter)) + (i * inter);
      gosen[j][Z] = gosen_base[j][Z];
    }

    glVertexPointer(3, GL_DOUBLE, 0, gosen);
    glColorPointer(4, GL_DOUBLE, 0, gosen_colors);
    glDrawElements(GL_QUADS, 24, GL_UNSIGNED_BYTE, cubeIndices);
  }

  *Ltop = gosen_base[1][Y] + ((*Lbot) + ((5 + 1) * inter)) + (4 * inter);

  /*  Ȳ  */
  xbm_put(0, (*Lbot) + (inter * 4) + 2, win_h, G_clef_width, G_clef_height, G_clef_bits, gosen_colors[0]);

  /*  ز  */
  xbm_put(0, (*Lbot) - (inter * 2) + 2, win_h, F_clef_width, F_clef_height, F_clef_bits, gosen_colors[0]);


  return (*Lbot);
}
