/* Time-stamp: <2005-05-19 09:26:14 >  */
#include  "4ru.h"

typedef struct on_time_list{
  double ot_w_diff;
  double val[VAL_MAX];      /*  Cxgp[^(l)
			     ident ̒lɂĂ܂܂ȃp[^li[
			     (̃t@C̏̒萔`t߂QƂ̂)             */
}OTL;

#define  LLEN 128


double gpr6_Z(NOTE_NODE *arg_bci, NOTE_NODE *arg_bcj, int arg_r, int person, double match_th)
{
  double ret;
  NOTE_NODE *bci = NULL;
  NOTE_NODE *bcj = NULL;
  int ir;
  int jr;
  OTL i_list[LLEN];
  OTL j_list[LLEN];
  int i;
  int j;
  int in;
  int jn;
  double tmp_max;
  double tmp_val;
  int max_j;
  int i_pitch_list[LLEN];
  int j_pitch_list[LLEN];
  int idx;
  int diff;


/*   koko_fl(-1);  print_node(arg_bci); */
/*   koko_fl(-1);  print_node(arg_bcj); */

  for(i = 0; i < LLEN; i++){
    i_list[i].ot_w_diff = -1;
    j_list[i].ot_w_diff = -1;
    i_pitch_list[i] = -1;
    j_pitch_list[i] = -1;
    for(j = 0; j < VAL_MAX; j++){
      i_list[i].val[j] = -1;
      j_list[i].val[j] = -1;
    }
  }

  ret = 0.0;


/*   koko_fl(-1);  printf("i: ------\n"); */
  bci = arg_bci;
  ir = arg_r;
  in = 0;
  while(1){
    if(bci == NULL){  break; }
    if(bci->ident == NOTE){
/*       koko_fl(-1); print_node(bci); */
      i_list[in].ot_w_diff = bci->on_time.beat + bci->on_diff.beat;
      i_list[in].val[NOTE_NO] = bci->val[NOTE_NO];
      in++;
      if( chk_gpr_bc(bci, person) == ON ){
	ir--;
	if(ir == 0){  break; }
      }
    }
    bci = bci->next;
  }

/*   koko_fl(-1);  printf("j: ------\n"); */
  bcj = arg_bcj;
  jr = arg_r;
  jn = 0;
  while(1){
    if(bcj == NULL){  break; }
    if(bcj->ident == NOTE){
/*       koko_fl(-1); print_node(bcj); */
      j_list[jn].ot_w_diff = bcj->on_time.beat + bcj->on_diff.beat;
      j_list[jn].val[NOTE_NO] = bcj->val[NOTE_NO];
      jn++;
      if( chk_gpr_bc(bcj, person) == ON ){
	jr--;
	if(jr == 0){  break; }
      }
    }
    bcj = bcj->next;
  }



  /*  ^C~O߂̂T  */

  for(i = 1; i < in; i++){
    i_list[i].ot_w_diff -= i_list[0].ot_w_diff;
  }
  i_list[0].ot_w_diff -= i_list[0].ot_w_diff;
  for(j = 1; j < jn; j++){
    j_list[j].ot_w_diff -= j_list[0].ot_w_diff;
  }
  j_list[0].ot_w_diff -= j_list[0].ot_w_diff;

  idx = 0;
  for(i = 0; i < in; i++){
    tmp_max = -1;
    max_j = 0;
    for(j = 0; j < jn; j++){
      tmp_val = normal_dist(0, 1.0, i_list[i].ot_w_diff - j_list[j].ot_w_diff);
      if(tmp_val > tmp_max){
	tmp_max = tmp_val;
	max_j = j;
      }
    }

    tmp_max /= normal_dist_0_1_0;
/*     koko_fl(-1);  printf("i_list[%d]: %5.3f\n", i, i_list[i].ot_w_diff); */
/*     koko_fl(-1);  printf("j_list[%d]: %5.3f\n", max_j, j_list[max_j].ot_w_diff); */
/*     koko_fl(-1);  printf("tmp_max: %5.3f: \n", tmp_max); */

    if(tmp_max >= match_th){
/*       koko_fl(-1); printf("accept\n"); */
      ret += tmp_max;
      j_list[max_j].ot_w_diff = -32768;
      i_pitch_list[idx] = i_list[i].val[NOTE_NO];
      j_pitch_list[idx] = j_list[max_j].val[NOTE_NO];
      idx++;
    }
  }

/*   for(i = 0; i < idx; i++){ */
/*     koko_fl(-1);  printf("%d\n", i_pitch_list[i]); */
/*   } */
/*   for(i = 0; i < idx; i++){ */
/*     koko_fl(-1);  printf("%d\n", j_pitch_list[i]); */
/*   } */

  ret = 0.0;
/*   koko_fl(-1);  printf("idx: %d\n", idx); */
  for(i = 1; i < idx; i ++){
    diff = (i_pitch_list[i] - i_pitch_list[i-1]) - (j_pitch_list[i] - j_pitch_list[i-1]);
/*     koko_fl(-1);  printf("%d\n", diff); */
/*     koko_fl(-1);  printf("%5.3f\n", normal_dist(0, 1.0, diff)/ normal_dist_0_1_0); */
    ret += normal_dist(0, 1.0, diff)/ normal_dist_0_1_0;
  }

  return ret;
}
