/*  Time-stamp: <2005-02-16 13:52:34 >  */
#include  "4ru.h"
#include  <glut.h>
#include  "GLcolors.h"


extern int menu_id;
extern int view_devi;
extern int view_score;
extern int disp_vel;
extern int loud_slope;
extern int note_head;
extern int disp_event;
extern NOTE_NODE *view_note_cur;
extern char gttm_line[STR_LEN];
extern int gttm_exec;

extern char arg_file[STR_LEN];
extern char out_note_file[STR_LEN];
extern NOTE_HEADER note_header_info;
extern NOTE_NODE *note_top;
extern WRITE_CTRL wctrl;

extern int scroll_play;
extern int win_w;
extern int win_h;


void mouse_menu(int sel)
{
  NOTE_NODE *org_view_note_cur;
  int str_x_bias;

  re_draw();  /*  "Scroll Play ON, OFF" ̕\D  */

  switch(sel){
  case  EXIT_MENU:
    exit(EXIT_SUCCESS);

  case  SCOREDISP_MENU:
    if(view_score == ON){
      view_score = OFF;
      glutChangeToMenuEntry(SCOREDISP_MENU, SCOREDISP_ON_STR, SCOREDISP_MENU);
    }else{
      view_score = ON;
      glutChangeToMenuEntry(SCOREDISP_MENU, SCOREDISP_OFF_STR, SCOREDISP_MENU);
    }

    glutPostRedisplay();
    break;
    

  case  DEVIDISP_MENU:
    if(view_devi == ON){
      view_devi = OFF;
      glutChangeToMenuEntry(DEVIDISP_MENU, DEVIDISP_ON_STR, DEVIDISP_MENU);
    }else{
      view_devi = ON;
      glutChangeToMenuEntry(DEVIDISP_MENU, DEVIDISP_OFF_STR, DEVIDISP_MENU);
    }

    glutPostRedisplay();
    break;
    
  case  DISP_VEL_MENU:
    if(disp_vel == ON){
      disp_vel = OFF;
      glutChangeToMenuEntry(DISP_VEL_MENU, DISP_VEL_ON_STR, DISP_VEL_MENU);
    }else{
      disp_vel = ON;
      glutChangeToMenuEntry(DISP_VEL_MENU, DISP_VEL_OFF_STR, DISP_VEL_MENU);
    }

    glutPostRedisplay();
    break;


  case  LOUD_MENU:
    if(loud_slope == ON){
      loud_slope = OFF;
      glutChangeToMenuEntry(LOUD_MENU, LOUD_ON_STR, LOUD_MENU);
    }else{
      loud_slope = ON;
      glutChangeToMenuEntry(LOUD_MENU, LOUD_OFF_STR, LOUD_MENU);
    }

    glutPostRedisplay();
    break;


  case  NOTE_HEAD_MENU:
    if(note_head == ON){
      note_head = OFF;
      glutChangeToMenuEntry(NOTE_HEAD_MENU, NOTE_HEAD_ON_STR, NOTE_HEAD_MENU);
    }else{
      note_head = ON;
      glutChangeToMenuEntry(NOTE_HEAD_MENU, NOTE_HEAD_OFF_STR, NOTE_HEAD_MENU);
    }

    glutPostRedisplay();
    break;


  case  DISP_EVENT_MENU:
    if(disp_event == ON){
      disp_event = OFF;
      glutChangeToMenuEntry(DISP_EVENT_MENU, DISP_EVENT_ON_STR, DISP_EVENT_MENU);
    }else{
      disp_event = ON;
      glutChangeToMenuEntry(DISP_EVENT_MENU, DISP_EVENT_OFF_STR, DISP_EVENT_MENU);
    }

    glutPostRedisplay();
    break;


  case  SCROLL_MENU:
    str_x_bias = 200;
    if(scroll_play == ON){
      scroll_play = OFF;
      glutChangeToMenuEntry(SCROLL_MENU, SCROLL_ON_STR, SCROLL_MENU);
      put_str_large(((win_w / 2) - str_x_bias), (win_h / 2), 0, OpenGLcolors[1], "Scroll Play OFF");
    }else{
      scroll_play = ON;
      glutChangeToMenuEntry(SCROLL_MENU, SCROLL_OFF_STR, SCROLL_MENU);
      put_str_large(((win_w / 2) - str_x_bias), (win_h / 2), 0, OpenGLcolors[1], "Scroll Play ON!");
    }

    glutSwapBuffers();  /*   SwapBuffers  */
    break;


  case  SMF_OUT_MENU:
    extern_SMF_out();
    break;

  case  PLAY_MENU:
    org_view_note_cur = view_note_cur;
    extern_sequence_play();
    view_note_cur = org_view_note_cur;
    re_draw();
    break;

  case  GPR_MENU:
    if(stricmp(gttm_line, "") == 0){
      strcpy(gttm_line, "m0");
    }
    if(gttm_exec == ON){
      gttm_exec = OFF;
      glutChangeToMenuEntry(GPR_MENU, GPR_ON_STR, GPR_MENU);
    }else{
      gttm_exec = ON;
      glutChangeToMenuEntry(GPR_MENU, GPR_OFF_STR, GPR_MENU);
      gttm(NULL);
    }
    re_draw();
    break;

  case  NOTE_OUT_MENU:
    NOTEfile_write(arg_file, out_note_file, &note_header_info, note_top, wctrl);
    break;

  case  XML_OUT_MENU:
    break;

  case  EXP_MENU:
    genchan();
    re_draw();
    break;


  default:
    break;
  }

  return;
}
