#include  <stdio.h>
#include  <stdlib.h>
#include  <math.h>
#include  <string.h>
#include  "SMFrw.h"
#include  "disp_ctr.h"


int smf_put_event(FILE **fp, EL *cur)
{
  static int pre_stat;
  int byte;
  int i;


  byte = 0;

  if(pre_stat != cur->stat){
    fprintf(*fp, "%c", cur->stat);
    pre_stat = cur->stat;
    byte = 1;
  }else{  /*  jOXe[^XKp邱Ƃ݂  */
    if((cur->stat & 0xf0) == 0xf0){
      fprintf(*fp, "%c", cur->stat);
      pre_stat = cur->stat;
      byte = 1;
    }
  }


  switch(cur->stat & 0xf0){
  case  0x80:
  case  0x90:
  case  0xa0:
  case  0xb0:
  case  0xe0:
    fprintf(*fp, "%c%c", cur->val1, cur->val2);
    byte += 2;

    return byte;

    
  case  0xc0:
  case  0xd0:
    fprintf(*fp, "%c", cur->val1);
    byte += 1;

    return byte;

    
  case  0xf0:
    if((cur->stat == 0xf0) || (cur->stat == 0xf7)){
      byte += smf_put_delta(fp, cur->val2);

      for(i = 0; i < cur->val2; i++){
	fprintf(*fp, "%c", cur->data[i]);
	byte++;
      }

      return byte;

    }else if(cur->stat == 0xff){	  
      fprintf(*fp, "%c", cur->val1);
      byte++;
      byte += smf_put_delta(fp, cur->val2);

      for(i = 0; i < cur->val2; i++){
	fprintf(*fp, "%c", cur->data[i]);
	byte++;
      }

      if(cur->val1 == 0x2f){
	pre_stat = 0;
      }
      
      return byte;

    }else{
      br_printf(2, "mʃ^Cxg %X(%c) łD\n", cur->val1, cur->val2);
      exit(EXIT_FAILURE);
    }

  default:
    br_printf(2, "m MIDI Cxg %X %d %d łD\n", cur->stat, cur->val1, cur->val2);
    exit(EXIT_FAILURE);
  }

  return byte;

}
