/*  Time-stamp: <04/07/15 17:38:38 noike>  */
#include  "4ru.h"


int arff_out(char *org_filename, NOTE_NODE *part_top[PART_NUM], PART_INFO  part_info[PART_NUM], int part_num,
	    NOTE_HEADER *note_header_info, WRITE_CTRL wctrl, PERF_CTRL pctrl)
{
  FILE *fp;
  char filename_arff[STR_LEN];
  char buf[STR_LEN];
  NOTE_NODE *cur;
  int i;

  /*  Warning к  */
  part_info = part_info;
  pctrl = pctrl;
  /*  Warning кޤ  */


  /*  MusicXML(4R) եΥե̾  */
  sprintf(filename_arff, "%s.arff", org_filename);

  /*  ¸եؤξ񤭥å  */
  if(wctrl.ow_chk == ON){
    if(exist_chk(filename_arff) == EXIST){
      br_printf(4, "%s", filename_arff);
      br_printf(-1, "  ");
      br_printf(3, "overwrite ok? (y/n)\n");
      fgets(buf, STR_LEN, stdin);
      if(tolower(buf[0]) != 'y'){
	br_printf(6, "not written %s.\n", filename_arff);
	return EXIT_FAILURE;
      }
    }
  }


  fp = fopen(filename_arff, "w");
  if(fp == NULL){
    br_printf(2, "ե %s ޤǤ\n", filename_arff);
    exit(EXIT_FAILURE);
  }

  br_printf(3, "%s", filename_arff);
  br_printf(-1, " Writing... ");


  fprintf(fp, "@relation %s\n", org_filename);
  fprintf(fp, "\n");
  fprintf(fp, "@attribute stime.beat  real\n");
  fprintf(fp, "@attribute on_diff  real\n");
  fprintf(fp, "@attribute note_no  integer\n");
  fprintf(fp, "@attribute vel  integer\n");
  fprintf(fp, "@attribute len.beat  real\n");
  fprintf(fp, "@attribute len_diff.beat  real\n");

  fprintf(fp, "\n");
  fprintf(fp, "@data\n");


  for(i = 0; i < PART_NUM; i++){
    note_time_consistency(part_top[i], note_header_info);  /*  T_BEAT, T_MEAN, T_REAL, T_DELTA  Τɤ줫ˡ
						     ľ  */
  }


  for(i = 0; i < part_num; i++){
    if(part_top[i] != NULL){
      break;
    }
  }
  if(i == part_num){
    br_printf(6, "%s: %d: note ǡޤ\n", __FILE__, __LINE__);
    exit(EXIT_FAILURE);
  }

  cur = part_top[i];
  while(cur != NULL){
    fprintf(fp, "%5.3f,%5.3f,%d,%d,%5.3f,%5.3f\n",
	    cur->on_time.beat,
	    cur->on_diff.beat,
	    (int)cur->val[0],
	    (int)cur->val[1],
	    cur->len.beat,
	    cur->len_diff.beat);
	    
    cur = cur->next;
  }

  fclose(fp);
  br_printf(4, "Ok!\n");
  
  return EXIT_SUCCESS;
}
