/*  Time-stamp: <2005-04-19 16:48:36 >  */
#include  "4ru.h"

int atehame(NOTE_NODE **srch, AHTBL atehame_tbl, DRUM_DEF *drum_data)
{
  NOTE_NODE *ex_top;
  NOTE_NODE *ex_cur;
  NOTE_NODE *same;
  NOTE_NODE *ex_same;
  NOTE_NODE *cur;
  NOTE_NODE *tmp;
  NOTE_HEADER dummy_note_header_info;
  double srch_on_time_bias;
  double ex_on_time_bias;
  double now_beattime;

/*   printf("file: %s\n", atehame_tbl.devifile); */
  if(exist_chk(atehame_tbl.devifile) != EXIST){
    return EXIT_SUCCESS;
  }

  ex_top = NOTEfile_read(atehame_tbl.devifile, &dummy_note_header_info, drum_data);

/*   ex_top = note_make_Ttree(ex_top, &dummy_note_header_info); */

  cur = *srch;
  srch_on_time_bias = (*srch)->on_time.beat;
  while(cur != NULL){
/*     printf("%d: %5.3f %s %5.3f\n", cur->number, cur->on_time.beat, cur->str[0], cur->len.beat); */
    if( (cur->ident == NOTE) || (cur->ident == REST) ){
      srch_on_time_bias = cur->on_time.beat;
      break;
    }
    cur = cur->next;
  }

  ex_cur = ex_top;
  ex_on_time_bias = ex_top->on_time.beat;
  while(ex_cur != NULL){
    if( (ex_cur->ident == NOTE) || (ex_cur->ident == REST) ){
      ex_on_time_bias = ex_cur->on_time.beat;
      break;
    }
    ex_cur = ex_cur->next;
  }



  /*  $BJ}K!(B 1 */
#if 1
  cur = *srch;
  while(cur != NULL){
    same = cur;
    while(same != NULL){
      if(same->ident == NOTE){

#if 1
	if(same->samepre != NULL){
	  if(same->val[0] == same->samepre->val[0]){
	    TFcopy(&(same->samepre->on_diff), &(same->on_diff));  /*  on_diff copy  */
	    same->samepre->val[1] = same->val[1];  /*  Velocity  */

	    /*  $B"-$b$7!$(BLen $B$,F1$8$@$C$?$i!$(BLen $B$bE,MQ(B  */
	    if(eq(same->samepre->len.beat, same->len.beat)){
	      TFcopy(&(same->samepre->len_diff), &(same->len_diff));  /*  len_diff copy  */
	    }

	    same = same->samenext;
	    continue;
	  }
	}
#endif

	ex_cur = ex_top;
	while(ex_cur != NULL){
	  if(same == NULL){  break; }
	  ex_same = ex_cur;
	  while(ex_same != NULL){
	    if(same == NULL){  break; }
	    if(ex_same->ident == NOTE){
	      /*  $B"-E,MQ>r7o(B  */
	      /*  $B"-(Bon_time $B$,F1$8$G!$(B  */
/* 	      printf("%5.3f %s %5.3f : %5.3f %s %5.3f\n", */
/* 		     same->on_time.beat - srch_on_time_bias, same->str[0], same->len.beat, */
/* 		     ex_same->on_time.beat - ex_on_time_bias, ex_same->str[0], ex_same->len.beat); */
	      if(eq(same->on_time.beat - srch_on_time_bias, ex_same->on_time.beat - ex_on_time_bias)
		 /*  $B"-2;9b$,F1$8$G(B  */  /*  $B2;9b$,0c$C$F$bE,MQ$G$-$k$h$&$K$9$kI,MW$"$j(B  */
/* 		 && (same->val[0] == ex_same->val[0]) */
/* 		 /\*  $B"-(BLen $B$,F1$8(B  *\/ */
/* 		 && (eq(same->len.beat, ex_same->len.beat)) */
		 ){
		TFcopy(&(same->on_diff), &(ex_same->on_diff));  /*  on_diff copy  */
		same->val[1] = ex_same->val[1];  /*  Velocity  */

		/*  $B"-$b$7!$(BLen $B$,F1$8$@$C$?$i!$(BLen $B$bE,MQ(B  */
		if(eq(same->len.beat, ex_same->len.beat)){
		  TFcopy(&(same->len_diff), &(ex_same->len_diff));  /*  len_diff copy  */
		}
		ex_same = ex_same->samenext;
		if(same != NULL){
		  same = same->samenext;
		}
	      }else{
		ex_same = ex_same->samenext;
	      }
	    }else{
	      ex_same = ex_same->samenext;
	    }
	  }
	  ex_cur = ex_cur->next;
	}
      }
      if(same != NULL){
	same = same->samenext;
      }
    }
    cur = cur->next;
  }
#endif



  /*  BEATTIME $B$rEv$F$O$a$^$7$g$&(B  */
  now_beattime = 1000.0;
  ex_cur = ex_top;
  while(ex_cur != NULL){
    ex_same = ex_cur;
    while(ex_same != NULL){
      if( (ex_same->ident == BEATTIME)
	  ||(ex_same->ident == DAMPER)
	  ){
	cur = *srch;
	while(cur != NULL){
	  /*  BEATTIME $BA^F~(B  */
	  if(cur->ident == BEATTIME){
	    now_beattime = cur->val[0];
	  }
	  if((cur->on_time.beat - srch_on_time_bias) >= (ex_same->on_time.beat- ex_on_time_bias)){
	    tmp = NOTE_NODE_alloc();
	    tmp->ident = ex_same->ident;
	    TFcopy(&(tmp->on_time), &(cur->on_time));  /*  NIME Rencon $B%(%s%H%j(B  */
	    tmp->on_time.beat -=
	      (ex_same->on_time.beat - ex_on_time_bias);  /*  $B$H$j$"$($:(B .beat $B$@$1(B  */

	    tmp->val[0] = ex_same->val[0];
	    tmp->val[1] = ex_same->val[1];
	    strcpy(tmp->str[0], ex_same->str[0]);
	    strcpy(tmp->str[1], ex_same->str[1]);
	    tmp->next = NULL;
	    tmp->pre = NULL;
	    tmp->samenext = NULL;
	    tmp->samepre  = NULL;
	    ins_node_pre(cur, tmp);
	    break;
	  }
	  cur = cur->next;
	}
      }

      ex_same = ex_same->samenext;
    }
    ex_cur = ex_cur->next;
  }
/*  BEATTIME $BEv$F$O$a$3$3$^$G(B  */


  return EXIT_SUCCESS;
}


