/* Time-stamp: <2005-08-15 22:17:45 >  */
#include  "4ru.h"

extern NOTE_HEADER note_header_info;

double get_top_beattime(NOTE_NODE *node)
{
  NOTE_NODE *cur;
  double qbeattime;
  double qbpm;

  /*  node 򤵤Τܤä node λǤ beattime   */
  cur = node;
  qbeattime = -1.0;

  if(note_header_info.beattime > 0){
    qbeattime = note_header_info.beattime * (16.0 / note_header_info.beattime_base);
  }else{
    qbpm = note_header_info.bpm / (16.0 / note_header_info.bpm_base);
    qbeattime = 60000.0 / qbpm;
  }

  while(1){
    print_node(cur);
    if(cur == NULL){  break; }
    if(cur->ident == BEATTIME){
      qbeattime = cur->val[0] * (16.0 / cur->val[1]);
      break;
    }
    else if(cur-> ident == BPM){
      qbpm = cur->val[0] / (16.0 / cur->val[1]);
      qbeattime = 60000.0 / qbpm;
      break;
    }
    cur = cur->pre;
  }

  return qbeattime;

}
