#include  "4ru.h"

extern int win_w;


/*  GPR3 change
    GPR3c articulation  */
int gpr3c(NOTE_NODE *linetop)
{
  NOTE_NODE *cur = NULL;
/*   NOTE_NODE *srch = NULL; */
  NOTE_NODE *n[4] = { NULL, NULL, NULL, NULL };
  NOTATIONS *artic[4] = { NULL, NULL, NULL, NULL };
  int slur_on_off[4];

  int slur_i;
  int i;


  cur = linetop;

  while(cur != NULL){
    if(cur->draw_xs >= (win_w + 128) ){  return  EXIT_SUCCESS; }

    if(get_n4(cur, n, -1) == EXIT_FAILURE){  return  EXIT_SUCCESS;  }
    /*
      n1 : n[0]
      n2 : n[1]
      n3 : n[2]
      n4 : n[3]
    */

    /*  notation Ȥ slur Ȥ artic Ȥ򸫤  */
    for(i = 0;i < 4; i++){
      artic[i] = &(n[i]->notations);
      for(slur_i = 0; slur_i < SLUR_NUM; slur_i++){
	if(artic[i]->slur[slur_i].type != NO_INFO){
	  slur_on_off[i] = ON;
	  break;
	}else{
	  slur_on_off[i] = OFF;
	}
      }
    }

    n[1]->GPR[GPR3c] = 0.0;


    /*  slur ѥѲå  */
    if( (slur_on_off[1] != slur_on_off[2]) &&
	(slur_on_off[0] == slur_on_off[1]) &&
	(slur_on_off[2] == slur_on_off[3]) ){
      n[1]->GPR_ON_OFF[GPR3c] = ON;
      n[1]->GPR[GPR3c] = 1.0;
    }else{
      n[1]->GPR_ON_OFF[GPR3c] = OFF;
      n[1]->GPR[GPR3c] = 0.0;
    }

    if(n[1]->org_node != NULL){
      n[1]->org_node->GPR[GPR3c] = n[1]->GPR[GPR3c];
      n[1]->org_node->GPR_ON_OFF[GPR3c] = n[1]->org_node->GPR_ON_OFF[GPR3c];
    }

    cur = cur->next;
  }

  return  EXIT_SUCCESS;
}
