/* Time-stamp: <2005-04-11 11:17:34 >  */
#include  "4ru.h"

extern int win_w;
extern NOTE_NODE *note_bot;

/*
  GPR6 (Parallelism)
Where two or more segments of the music can be construed as parallel,
they preferably form  parallel parts of groups.
*/

int h_gpr6(NOTE_NODE *linetop)
{
  NOTE_NODE *cur;
  NOTE_NODE *top_note;
  NOTE_NODE *n_note;
  NOTE_NODE *n[4];
  double ioisum;

  double rest23;
  double rest12;
  double rest34;

  double rest_r23;
  double rest_r12;
  double rest_r34;

  double ioi23;
  double ioi12;
  double ioi34;

  double t12_bias = 0.0;
  double t34_bias = 0.0;

  br_printf(6, "y̔񂪕K{̒莮Ȃ̂ŁCrł߂D\n");
  return EXIT_SUCCESS;


  /*  qi ߂ */
  /* ܂C擪̉T */
  top_note = linetop;
  while(1){
    if(top_note == NULL){    return EXIT_FAILURE; }
    print_node(top_note);
    if(top_note->ident == NOTE){  break; }
    top_note = top_note->next;
  }
  br_printf(4, "擪̉: ");
  print_node(top_note);

  /*  IOI  qi ߂  */
  cur = top_note;
  while(1){
    if(cur == NULL){    return EXIT_FAILURE; }
    if(cur->ident == NOTE){
      n_note = cur->next;
      while(1){
	if(n_note == NULL){  break; }
	if(n_note->ident == NOTE){
	  ioisum = (n_note->on_time.beat + n_note->on_diff.beat) - (top_note->on_time.beat + top_note->on_time.beat);
	  cur->cgpr6.q = floor(ioisum / 1);
	  br_printf(5, "IOIsum: %5.3f, %5.3f\n", ioisum, cur->cgpr6.q);
	  print_node(cur);
	  break;
	}
	n_note = n_note->next;
      }
    }
    cur = cur->next;
  }

  return EXIT_SUCCESS;


  cur = linetop;
  while(1){
    if(cur->draw_xs >= (win_w + 128) ){  return  EXIT_SUCCESS; }
    t12_bias = 0.0;
    t34_bias = 0.0;

    if(get_n4(cur, n, -1) == EXIT_FAILURE){  return  EXIT_SUCCESS;  }
    /*
      n1 : n[0]
      n2 : n[1]
      n3 : n[2]
      n4 : n[3]
    */

    rest23 =
      (n[2]->on_time.beat + n[2]->on_diff.beat) - 
      (n[1]->on_time.beat + n[1]->on_diff.beat + n[1]->len.beat + n[1]->len_diff.beat);
    /*    t23 = t23 / n2.len;  */

    rest12 =
      (n[1]->on_time.beat + n[1]->on_diff.beat) -
      (n[0]->on_time.beat + n[0]->on_diff.beat + n[0]->len.beat + n[0]->len_diff.beat);
    /*  t12 = t12 / n1.len;  */

    rest34 =
      (n[3]->on_time.beat + n[3]->on_diff.beat) -
      (n[2]->on_time.beat + n[2]->on_diff.beat + n[2]->len.beat + n[2]->len_diff.beat);
    /*  t34 = t34 / n3.len;  */

    ioi23 =
      (n[2]->on_time.beat + n[2]->on_diff.beat) - 
      (n[1]->on_time.beat + n[1]->on_diff.beat);
    ioi12 =
      (n[1]->on_time.beat + n[1]->on_diff.beat) -
      (n[0]->on_time.beat + n[0]->on_diff.beat);
    ioi34 =
      (n[3]->on_time.beat + n[3]->on_diff.beat) -
      (n[2]->on_time.beat + n[2]->on_diff.beat);

    rest_r23 = rest23 / ioi23;
    rest_r12 = rest12 / ioi12;
    rest_r34 = rest34 / ioi34;

    n[1]->GPR[GPR2a] = ((rest23 - rest12) + (rest23 - rest34)) / ioi23;

    if( (rest23 >= 0.0) &&
	(((rest12 + t12_bias) < rest23) && (rest23 > (rest34 + t34_bias))) ){
      n[1]->GPR_ON_OFF[GPR2a] = ON;
    }else{
      n[1]->GPR_ON_OFF[GPR2a] = OFF;
    }

    if(n[1]->org_node != NULL){
      n[1]->org_node->GPR[GPR2a] = n[1]->GPR[GPR2a];
      n[1]->org_node->GPR_ON_OFF[GPR2a] = n[1]->GPR_ON_OFF[GPR2a];
    }


/*     if( ((rest_r23 >= 0.0) && */
/* 	 ((rest_r12 + rest_r12_bias) < rest_r23) && (rest_r23 > (rest_r34 + rest_r34_bias))) && */
/* 	(eq((rest_r12 + rest_r12_bias), rest_r23) == 0) && (eq(rest_r23, (rest_r34 + rest_r34_bias)) == 0) ){ */
/*       n[1]->GPR_ON_OFF[GPR2a] = n[1]->org_node->GPR_ON_OFF[GPR2a] = ON; */
/*     }else{ */
/*       n[1]->GPR_ON_OFF[GPR2a] = n[1]->org_node->GPR_ON_OFF[GPR2a] = OFF; */
/*     } */

    cur = cur->next;
  }

  return  EXIT_SUCCESS;
}
