/*  Time-stamp: <2005-04-19 18:08:21 >  */
#include  "4ru.h"
#include  <glut.h>

extern int event_grab;
extern NOTE_NODE *srch_cur;
extern double ppqbeat;

extern double Lbot;
extern double inter;
extern double Velbot;
extern double Veltop;
extern double alpha;
extern double draw_on_time_bias;

extern int win_w;
extern int win_h;

extern int shift_key;
extern int ctrl_key;
extern DRUM_DEF drum_data[DRUM_KIND];


void modify_event(int x, int y)
{
  GLdouble event_colors[8][4];

/*   print_node(srch_cur); */


/*   printf("modify: (%d, %d) [(%d, %d)][(%d, %d),(%d, %d)][(%d, %d)]\n", */
/* 	 x, y, */
/* 	 (int)srch_cur->draw_xs, */
/* 	 (int)srch_cur->draw_ys, */
/* 	 (int)srch_cur->draw_norm_xs, */
/* 	 (int)srch_cur->draw_norm_ys, */
/* 	 (int)srch_cur->draw_norm_xe, */
/* 	 (int)srch_cur->draw_norm_ye, */
/* 	 (int)srch_cur->draw_xe, */
/* 	 (int)srch_cur->draw_ye */
/* 	 ); */
/*     printf("on_diff: %5.3f, len_diff: %5.3f\n", srch_cur->on_diff.beat, srch_cur->len_diff.beat); */
/*   printf("y: %d, Velbot: %d, vel: %d\n", y, (int)Velbot, (int)srch_cur->val[ON_VEL]); */

  if(event_grab == ON_DIFF_GRAB){
/*     printf("%5.3f\n", ((srch_cur->draw_norm_xs - x) / ppqbeat)); */

    srch_cur->on_diff.beat = ((x - srch_cur->draw_norm_xs) / ppqbeat);
    srch_cur->on_diff.meas = ((x - srch_cur->draw_norm_xs) / ppqbeat);
    srch_cur->on_diff.q_time = ((x - srch_cur->draw_norm_xs) / ppqbeat);

    if(srch_cur->len_diff.beat < 0.0){
      srch_cur->len_diff.beat = ((srch_cur->draw_xe - srch_cur->draw_norm_xe) / ppqbeat) - srch_cur->on_diff.beat;
      srch_cur->len_diff.meas = ((srch_cur->draw_xe - srch_cur->draw_norm_xe) / ppqbeat) - srch_cur->on_diff.meas;
      srch_cur->len_diff.q_time = ((srch_cur->draw_xe - srch_cur->draw_norm_xe) / ppqbeat) - srch_cur->on_diff.q_time;
    }else if(srch_cur->len_diff.beat >= 0.0){
      srch_cur->len_diff.beat = ((srch_cur->draw_xe - srch_cur->draw_norm_xe) / ppqbeat) - srch_cur->on_diff.beat;
      srch_cur->len_diff.meas = ((srch_cur->draw_xe - srch_cur->draw_norm_xe) / ppqbeat) - srch_cur->on_diff.meas;
      srch_cur->len_diff.q_time = ((srch_cur->draw_xe - srch_cur->draw_norm_xe) / ppqbeat) - srch_cur->on_diff.q_time;
    }

  }else if(event_grab == LEN_DIFF_GRAB){
    srch_cur->len_diff.beat = ((x - srch_cur->draw_norm_xe) / ppqbeat);
    srch_cur->len_diff.meas = ((x - srch_cur->draw_norm_xe) / ppqbeat);
    srch_cur->len_diff.q_time = ((x - srch_cur->draw_norm_xe) / ppqbeat);
  }else if(event_grab == ON_VEL_GRAB){
    srch_cur->val[ON_VEL] = ((win_h - y) - Velbot) / ((Veltop - Velbot) / 127.0);
    if(srch_cur->val[ON_VEL] > 127){
      srch_cur->val[ON_VEL] = 127;
    }
    if(srch_cur->val[ON_VEL] < 1){
      srch_cur->val[ON_VEL] = 1;
    }
  }else if(event_grab == OFF_VEL_GRAB){
    srch_cur->val[OFF_VEL] = (Velbot - (win_h - y)) / ((Veltop - Velbot) / 127.0);
    if(srch_cur->val[OFF_VEL] > 127){
      srch_cur->val[OFF_VEL] = 127;
    }
    if(srch_cur->val[OFF_VEL] < 1){
      srch_cur->val[OFF_VEL] = 1;
    }
  }


  if(srch_cur == NULL){
    return;
  }

  if(srch_cur->copy_node != NULL){
    srch_cur->copy_node->len_diff.beat = srch_cur->len_diff.beat;
    srch_cur->copy_node->len_diff.meas = srch_cur->len_diff.meas;
    srch_cur->copy_node->len_diff.q_time = srch_cur->len_diff.q_time;
    
    srch_cur->copy_node->on_diff.beat = srch_cur->on_diff.beat;
    srch_cur->copy_node->on_diff.meas = srch_cur->on_diff.meas;
    srch_cur->copy_node->on_diff.q_time = srch_cur->on_diff.q_time;

    srch_cur->copy_node->val[ON_VEL] = srch_cur->val[ON_VEL];
  }

  re_draw();
  set_event_colors("pink", event_colors);
  draw_event(srch_cur, Lbot, inter, Velbot, Veltop, ppqbeat, alpha, draw_on_time_bias, event_colors, drum_data);
  draw_str_note(srch_cur, win_w, win_h, x, win_h - y, 3);
  glutSwapBuffers();


  return;
}
