#include  "xml2note.h"


int part_sort(NOTE_NODE *part_top[PART_NUM], int part_num)
{
  NOTE_NODE *part_cur;
  NOTE_NODE *movenode;
  NOTE_NODE *srchnode;
  int part_idx;

  for(part_idx = 0; part_idx < part_num; part_idx++){
    part_cur = part_top[part_idx];
    while(part_cur != NULL){
      if(part_cur->next == NULL){
	break;
      }
      if(part_cur->xml_on_time.beat > part_cur->next->xml_on_time.beat){
	movenode = part_cur->next;
	part_cur->next = movenode->next;
	if(part_cur->next != NULL){
	  part_cur->next->pre = part_cur;
	}
	srchnode = part_cur->pre;
	while(1){
	  if(srchnode == NULL){  /*  $B@hF,$KC#$7$F$7$^$C$?$N$G!$@hF,$K(B movenode $B$rA^F~$9$k(B  */
	    movenode->next = part_top[part_idx];
	    movenode->next->pre = movenode;
	    part_top[part_idx] = movenode;
	    part_top[part_idx]->pre = NULL;
	    break;
	  }else{
	    if(srchnode->xml_on_time.beat <= movenode->xml_on_time.beat){  /*  srchnode $B$N<!$K(B movenode $B$rA^F~$9$k(B  */
	      movenode->next = srchnode->next;
	      movenode->next->pre = movenode;
	      srchnode->next = movenode;
	      srchnode->next->pre = srchnode;
	      break;
	    }
	  }
	  srchnode = srchnode->pre;
	}
      }else{
	part_cur = part_cur->next;
      }
    }
  }

#if 0
  for(part_idx = 0; part_idx < part_num; part_idx++){
    part_cur = part_top[part_idx];
    while(part_cur->next != NULL){
      printf("%5.3f\n", part_cur->xml_on_time);
      if(part_cur->xml_on_time > part_cur->next->xml_on_time){
	printf("%d: xml_on_tim: %f: %d\n", part_idx, part_cur->xml_on_time, part_cur->ident);
	printf("%d: xml_on_tim: %f: %d\n", part_idx, part_cur->next->xml_on_time, part_cur->next->ident);
	exit(0);
      }	
      part_cur = part_cur->next;
    }
  }
  printf("Sorting Ok!\n");
  exit(0);
#endif
  
 return 0;
}

